## ctwm 4.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(ctwm C)

# Figure our version
file(READ "VERSION" vf_str)
string(STRIP ${vf_str} vf_str)
# Not currently using the split out variants
if(0)
	set(version_file_re "([0-9]+)\\.([0-9]+)\\.([0-9]+)(.*)")
	string(REGEX REPLACE ${version_file_re} "\\1" ctwm_version_major ${vf_str})
	string(REGEX REPLACE ${version_file_re} "\\2" ctwm_version_minor ${vf_str})
	string(REGEX REPLACE ${version_file_re} "\\3" ctwm_version_patch ${vf_str})
	string(REGEX REPLACE ${version_file_re} "\\4" ctwm_version_addl  ${vf_str})
	set(ctwm_version_str "${ctwm_version_major}.${ctwm_version_minor}.${ctwm_version_patch}${ctwm_version_addl}")
else()
	set(ctwm_version_str ${vf_str})
endif()

# Modules we'll need
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)

# Guard against in-tree builds
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" insrc)
if(insrc)
	message(FATAL_ERROR "Please build out of tree; don't run cmake "
			"directly in the source tree.")
endif(insrc)


#
# Most of our bits are broken out into smaller files in a local dir
#
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake_files)

# Setup basic vars for where our pieces are, list of source files, etc.
include(basic_vars)

# Do some basic checks of the compiler and stdlib
include(compiler_feature_checks)

# Set our install paths
include(install_paths)


#
# First things first.  If we don't have X, we're going nowhere.
#
find_package(X11)
if(NOT X11_FOUND)
	# This just isn't feasible...
	message(FATAL_ERROR "Can't find X libs.")
endif(NOT X11_FOUND)
if(NOT X11_INCLUDE_DIR)
	message(FATAL_ERROR "Can't find X includes.")
endif(NOT X11_INCLUDE_DIR)

include_directories(${X11_INCLUDE_DIR})

# Need to link in at least these; double check that we found 'em before
# blindly applying them.  We can seemingly get through the above just
# fine, even if it didn't find all the bits...
foreach(VEXT LIBRARIES Xmu_LIB Xt_LIB)
	if(NOT X11_${VEXT})
		message(FATAL_ERROR "Can't find X11_${VEXT}; missing lib or "
			"-devel package?")
	endif()
	list(APPEND CTWMLIBS ${X11_${VEXT}})
endforeach()


#
# Setup some search paths
#
set(INCSEARCH
	"${CMAKE_INSTALL_PREFIX}/include"
	${X11_INCLUDE_DIR}
	"/usr/local/include"
	"/usr/include"
)
set(LIBSEARCH
	"${CMAKE_INSTALL_PREFIX}/lib"
	${X11_LIBRARY_DIR}
	"/usr/local/lib"
	"/usr/lib"
	"/lib"
)

# Header files are in both source and build dirs
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})


#
# Look for various things on the system and setup our handlers for them,
# and put the build together.
#

# Check our build options and set things based on them
include(build_options)

# Do checks for library functions we need, and enable workarounds for any
# cases we decide are worth handling that way.
include(check_funcs_etc)

# If we're building out of a VCS, find those bits so we can stash the
# revision info.
include(vcs_checks)

# Find some tools used for generating sources and manuals, and setup the
# targets to build them all.
include(setup_lex)
include(setup_yacc)
include(handle_manual)
include(gen_source_files)

# Targets to run doxygen and ctags; nobody but devs care
include(doxygen)
include(ctags)


# And link up the actual ctwm binary.  We actually build a libctwmlib
# with all our contents except the trivial main() wrapper, then build
# ctwm with that; this makes it easy to build other binaries (like tests)
# with access to all our internal funcs.
add_library(ctwmlib STATIC ${CTWMSRC})
add_executable(ctwm "ctwm_wrap.c")

# Keep ctwmlib before the shared libs.  With some ld(1)'s and build
# environments that set --as-needed, having it after means that ld will
# have already discarded all the shared libs as "unused" before it gets
# to all the actual ctwm objects that need the symbols.
target_link_libraries(ctwm ctwmlib)
target_link_libraries(ctwm ${CTWMLIBS})

# This doesn't really serve much purpose at the moment, so it's not even
# documented, but the code exists.  So make it buildable.
if(DO_CLIENT)
	add_subdirectory(client)
endif(DO_CLIENT)


# Setup the installation
include(do_install)


#
# And some trailing misc bits
#

# Pull in some CPack config for auto-building packages (like .deb and
# .rpm)
include(cpack_setup)

# Some targets to support release management stuff; building generated
# files for the tarballs
include(mktar_support)

# Pull in dtrace bits
include(dtrace_support)

# Let cmake write out compile commands for external tools.  Requires
# cmake 3.5+, but setting an unknown var won't hurt earlier versions.
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

# Include tests
include(CTest)
if(BUILD_TESTING)
	enable_testing()
	add_subdirectory(tests)
endif()

# Finish by outputting various information about what we've figured and
# what we're doing for the builder's edification.
include(show_build_info)

=== Makefile ===
# This just shortcuts stuff through to cmake
all build ctwm man man-html man-all install clean: build/Makefile
	( cd build && ${MAKE} ${@} )

build/Makefile cmake: CMakeLists.txt
	( mkdir -p build && cd build && \
		cmake -DCMAKE_C_FLAGS:STRING="${CFLAGS}" ${CMAKE_EXTRAS} .. )

allclean distclean:
	rm -rf build/*



#
# The below targets are mostly only of interest to developers
#

# Add'l thunks to cmake
.PHONY: tags
man-pdf doxygen doxyclean tags: build/Makefile
	( cd build && ${MAKE} ${@} )

# Make sure everything's build before running tests
.PHONY: test
test:
	( cd build && ${MAKE} test_bins )
	( cd build && ${MAKE} CTEST_OUTPUT_ON_FAILURE=1 ${@} )

# Reindent files
indent:
	astyle -n --options=tools/ctwm.astyle *.h *.c


# Build documentation files
DOC_FILES=README.html CHANGES.html
docs: ${DOC_FILES}
docs_clean doc_clean:
	rm -f ${DOC_FILES}

.SUFFIXES: ${.SUFFIXES} .html .md
.md.html:
	multimarkdown -afo ${@} ${<}


# asciidoc files
UMAN=doc/manual
adocs:
	(cd ${UMAN} && make all_set_version)
adocs_pregen:
	(cd ${UMAN} && make all)
adoc_clean:
	(cd ${UMAN} && make clean)


#
# Pre-build some files for tarballs
#
GEN=gen
${GEN}:
	mkdir -p ${GEN}

# All the generated source files
_RELEASE_FILES=gram.tab.c gram.tab.h lex.c version.c.in ctwm.1 ctwm.1.html
RELEASE_FILES=${_RELEASE_FILES:%=${GEN}/%}

# Build those, the .html versions of the above docs, and the HTML/man
# versions of the manual
release_files: ${GEN} build/MKTAR_GENFILES ${RELEASE_FILES} ${DOC_FILES}
release_clean: doc_clean adoc_clean
	rm -rf ${GEN}

# Stuff for thunking to cmake
build/MKTAR_GENFILES: build/Makefile
	(cd build ; make mktar_genfiles)

# The config grammar
${GEN}/gram.tab.c: ${GEN}/gram.tab.h
${GEN}/gram.tab.h: ${GEN} gram.y build/MKTAR_GENFILES
	cp build/gram.tab.[ch] ${GEN}/

${GEN}/lex.c: ${GEN} lex.l build/MKTAR_GENFILES
	cp build/lex.c ${GEN}/

# Setup version file
${GEN}/version.c.in: ${GEN} version.c.in .bzr/checkout/dirstate
	tools/rewrite_version_bzr.sh < version.c.in > ${GEN}/version.c.in

# Generate pregen'd manuals
${GEN}/ctwm.1: ${UMAN}/ctwm.1
${GEN}/ctwm.1.html: ${UMAN}/ctwm.1.html
${GEN}/ctwm.1 ${GEN}/ctwm.1.html:
	cp ${UMAN}/ctwm.1 ${UMAN}/ctwm.1.html ${GEN}/
${UMAN}/ctwm.1 ${UMAN}/ctwm.1.html:
	(cd ${UMAN} && make clean all)


# Thunk through to gen'ing tarball
tar:
	tools/mk_tar.sh

=== client/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# Build the libctwm_client library
add_library(ctwmc SHARED libctwm.c)

# There's a demolib that links against it
add_executable(demolib demolib.c)
target_link_libraries(demolib ctwmc ${X11_LIBRARIES})

# There's also a 'gtw' that doesn't, but is sorta client-like...
add_executable(gtw gtw.c)
target_link_libraries(gtw ${X11_LIBRARIES})

# A program to [attempt to] forward keystrokes from layered root-ish
# windows.
add_executable(forward forward.c)
target_link_libraries(forward ${X11_LIBRARIES})


# Meta-target
add_custom_target(client
	DEPENDS demolib gtw
)

# Mention it
message(STATUS "Building libctwmc and demolib.")

=== tests/CMakeLists.txt ===
#
# Automated tests
#

set(CTWMBIN "${CMAKE_BINARY_DIR}/ctwm")
add_custom_target(test_bins)
add_dependencies(test_bins ctwm)


# Add some infrastructure for building executables for unit tests
macro(ctwm_simple_unit_test BIN)
	# Building and linking it
	add_executable(${BIN} EXCLUDE_FROM_ALL "${BIN}.c")
	target_link_libraries(${BIN} ctwmlib)

	# Few of our tests really need any of the X or other libs we pull in.
	# However, most of the .o's for ctwm itself are going to have some
	# ref out to them somewhere, so any tests that wind up pulling
	# functions from those are going to make the linker want to resolve
	# them when we link ${BIN}.  So just unconditionally add them and
	# don't worry about which tests may not actually need 'em.
	target_link_libraries(${BIN} ${CTWMLIBS})

	# Add to pre-test target
	add_dependencies(test_bins ${BIN})

	# And add the test itself
	add_test(NAME ${BIN}
		COMMAND $<TARGET_FILE:${BIN}>
		)
endmacro()



# First a simple smoke test of the built binary
add_test(NAME run-info
	COMMAND ${CTWMBIN} --info
	)
set_tests_properties(run-info PROPERTIES
	PASS_REGULAR_EXPRESSION "Twm version: "
	)


# Try parsing the system.ctwmrc
# Have to support skipping if no $DISPLAY is set, since we require
# talking to the X server to get far enough to cfgchk.  Should really
# find a way around that, but it's a lot more involved than you'd think,
# so 'till then...
add_test(NAME cfgchk
	COMMAND sh -c "[ -z \"\$DISPLAY\" ] && exit 99 ; ${CTWMBIN} --cfgchk -f ${CMAKE_SOURCE_DIR}/system.ctwmrc"
	)
set_tests_properties(cfgchk PROPERTIES
	# XXX Requires cmake 3.0...
	SKIP_RETURN_CODE 99
	)


# Simple test of m4 preprocessing, but we skip if built without m4.
# XXX Gotta skip if no $DISPLAY here too.  Fix that   :(
# XXX This seems like the simplest way of actually "skip"'ing a test
# based on configure options.  That's nuts.  REQUIRED_FILES sounds like
# it would, but actually causes the test to "not run" and be considered
# failed   :(
if(USE_M4)
	set(_test_m4_cmd
		"[ -z \"\$DISPLAY\" ] && exit 99 \\; ${CTWMBIN} --cfgchk -f ${CMAKE_CURRENT_SOURCE_DIR}/test_m4/ctwmrc"
		)
else()
	set(_test_m4_cmd "echo Built without m4, skipping \\; exit 99")
endif()
add_test(NAME test_m4
	COMMAND sh -c ${_test_m4_cmd}
	)
set_tests_properties(test_m4 PROPERTIES
	SKIP_RETURN_CODE 99
	)


# A first run at a unit test
add_subdirectory(util_expand)

=== doc/manual/Makefile ===
BASE=ctwm.1

HTML=${BASE}.html

html: ${HTML}
man: ${BASE}

all: html man

all_set_version: all
	sed -i '' -e "s/@ctwm_version_str@/`head -1 ../../VERSION`/" ${HTML} ${BASE}

clean:
	rm -f ${BASE} ${HTML}


# asciidoc vs asciidoctor notes:
#
# Note that asciidoctor has a slightly changed dialect, so there may be
# minor differences in the output.  Also, the manpage generation requires
# 1.5.3+.  At the moment, we're trying to work with both.  Current trends
# suggest that at some point asciidoctor will be the de facto
# asciidoc-world implementation, so we may drop the py-asciidoc at some
# point.  For the moment, asciidoctor is treated as the standard
# renderer, with asciidoc being a fallback we try to keep working well.


# Generating HTML output by various means
html-asciidoc: ${BASE}.adoc
	asciidoc -atoc -anumbered -o ${BASE}.html ${BASE}.adoc

html-asciidoctor: ${BASE}.adoc
	asciidoctor -atoc -anumbered -o ${BASE}.html ${BASE}.adoc


# Manpage output.  x-ref comment above about asciidoctor versions
man-asciidoc-a2x: ${BASE}.adoc
	a2x --doctype manpage --format manpage ${BASE}.adoc

man-asciidoc-adoc: ${BASE}.adoc
	asciidoc -b docbook -d manpage -o ${BASE}.xml ${BASE}.adoc
	xmlto man ${BASE}.xml

man-asciidoctor: ${BASE}.adoc
	asciidoctor -b manpage -o ${BASE} ${BASE}.adoc



# Set which are used by default.  Set to asciidoctor since it's massively
# faster.
${HTML}: ${BASE}.adoc
	@${MAKE} html-asciidoctor

${BASE}: ${BASE}.adoc
	@${MAKE} man-asciidoctor

=== tests/util_expand/CMakeLists.txt ===
# Test ExpandFilePath()
ctwm_simple_unit_test(t_efp)

## ctwm 3.7

=== debian/changelog ===
ctwm (3.7-5) unstable; urgency=medium

  * QA upload.
  * Fix ftbfs with GCC-10. (Closes: #957114)
  * Update Standards-Version to 4.5.0
  * Use debhelper-compat.
    - Update to compat level 13.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 05 Aug 2020 16:31:12 +0100

ctwm (3.7-4) unstable; urgency=medium

  * QA upload.
  * Orphan the package.
  * Source format 3.0 (quilt).
  * Debhelper compat 9; closes: #817322, #817416.
  * Drop readme.vms; closes: #367356.
  * Fix a segfault on workspace switch; closes: #662860.
  * Don't ignore errors from make.
  * Drop vim droppings from the end of the changelog.
  * Fix a crash on showing the windowlist; closes: #649671.
  * Pick an upstream fix for workspace manager drag; closes: #585693.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 04 Aug 2016 09:33:17 +0200

ctwm (3.7-3.3) unstable; urgency=low

  * Non-maintainer upload.
  * Correctly remove the x-window-manager alternative on package removal.
    (Closes: #668449)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 30 Jan 2013 15:35:21 +0100

ctwm (3.7-3.2) unstable; urgency=low

  * Non-maintainer upload.
  * Build-depend on libjpeg-dev, not libjpeg62-dev (closes: #641105)

 -- Julien Cristau <jcristau@debian.org>  Sun, 29 Jan 2012 16:49:16 +0100

ctwm (3.7-3.1) unstable; urgency=low

  [Jari Aalto]
  * Non-maintainer upload.
  * debian/control
    - (Build-Depends): update obsolete x-dev to x11proto-core-dev.
      (important RC bug; Closes: #515492).
  * debian/rules
    - (build-stamp): Define CC before call to xmkmf(1).

 -- Jari Aalto <jari.aalto@cante.net>  Sat, 27 Mar 2010 14:57:01 +0200

ctwm (3.7-3) unstable; urgency=low

  * Merge Luk Claes's NMU.  Thanks, Luk!  Luk's changes are:
    + Make ctwm pre-depend on x11-common (>= 1:7.0.0).
    + Correct comment in the menu-method file.
    + I reverted Luk's deletion of the SVN Id keyword and Vim modeline in this
      changelog.  (We finally got a comment character for control files, now
      we need one for changelogs as well.  Lesson?  Never, ever, ever, ever
      make a file format that will be machine-parsed by anything without
      supporting comments.  ALGOL 60 called and wants its innovations back.)
  * I had already done the following in SVN but was too slow to release.
    Shame on me.
    + Build-depend on xutils-dev instead of xutils for the X11R7 transition.
    + Adjust debian/rules and debian/postinst to use FHS paths, moving from
      /usr/X11R6 to /usr.  Based on a patch by Steve Langasek.  Thanks, Steve!
      (Closes: #364239)
    + Point menu-method to install-menu interpreter in /usr/bin, not
      /usr/sbin, per Lintian.
    + Add empty binary-indep target in debian/rules to quiet Lintian error.
  * Fix SEGV when attempting to bring up the TwmWindows menu when no workspace
    manager is active.  Thanks to Mike O'Connor for the analysis and the
    patch! (Closes: #375240)
  * Bump Standards-Version from 3.6.2 to 3.7.2; required changes involving
    placement of files in X11 paths and pre-dependency on x11-common made as
    described above.

 -- Branden Robinson <branden@debian.org>  Fri, 21 Jul 2006 10:27:56 -0400

ctwm (3.7-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * High-urgency upload for RC bugfix.
  * Build-depend against xutils-dev for the X11R7 transition, pre-depend on
    a recent x11-common and adjust debian/rules for the FHS paths
    (Closes: #364239).

 -- Luk Claes <luk@debian.org>  Fri, 12 May 2006 22:35:26 +0200

ctwm (3.7-2) unstable; urgency=low

  * Add build-dependency on libjpeg62-dev to fix FTBFS.  Shame on me for not
    building in a clean chroot.

 -- Branden Robinson <branden@debian.org>  Wed,  2 Nov 2005 15:00:00 -0500

ctwm (3.7-1) unstable; urgency=low

  * Merge upstream 3.7 release.
    + The upstream maintainer is now Richard Levitte, not Claude Lecommandeur.
    + Add workspace context for keybindings.
    + Add AlwaysSqueezeToGravity configuration keyword and feature.
    + Add TwmKeys and TwmVisible menus.
    + Implement preliminary GNOME compliance (see README.gnome and TODO.gnome
      in /usr/share/doc/ctwm.)
    + Add IconifyStyle configuration keyword and feature for "fancy" graphical
      effects.
    + Add JPEG/JFIF image support, using "jpeg:filename" syntax.
    + Add f.showbackground action, which unmaps all windows in the current
      workspace.
    + Add preliminary support for Xinerama extension using the VirtualScreens
      configuration keyword.
    + Change Imakefile to support a distribution target.
    + Change :xpm:cross to be a bit larger, appear more three-dimensional, and
      be more visible even in very dark configurations.
    + Make AlwaysSqueezeToGravity work for all windows if no window list is
      given.
    + Add NoImagesInWorkSpaceManager configuration keyword and feature which
      prevents background images from being displayed in the workspace map.
    + Add -cfgchk command-line option, which simply performs a parse check on
      the configuration file, without launching the window manager.
    + Change the behavior of DontMoveOff/MoveOffResistance (see upstream
      changelog).
    + Change behavior of random placement to respect DontMoveOff (see upstream
      changelog).
    + Change f.warpring action so that the icon manager doesn't get enter and
      leave events if IconManagerFocus is set.
    + Add f.movetoprevworkspace, f.movetonextworkspace,
      f.movetoprevworkspaceandfollow, and f.movetonextworkspaceandfollow
      actions (see upstream changelog).
    + Add "vertical" as a parameter to the f.fill action (see upstream
      changelog).
    + Add hack to ensure that a window that had been maximized keeps the focus
      when it is restored to its previous size.
    + Fix f.zoom action to stop moving the window up.
    + Add IgnoreTransient configuration keyword and feature to ignore a
      specified list of transient windows.


=== debian/control ===
Source: ctwm
Section: x11
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: x11proto-core-dev, libice-dev, libsm-dev, libx11-dev,
 libxext-dev, libxmu-dev, libxpm-dev, libxt-dev, librplay3-dev, libjpeg-dev,
 xutils-dev, flex, bison, debhelper-compat (= 13)
Standards-Version: 4.5.0

Package: ctwm
Architecture: any
Depends: m4, ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: x11-common (>= 1:7.0.0)
Provides: x-window-manager
Description: Claude's Tab window manager
 ctwm is Claude Lecommandeur's extension to twm; in addition to the
 features of twm, it supports multiple virtual screens, the pixmap file
 format, pinnable ("sticky") menus, and other enhancements.

=== debian/rules ===
#!/usr/bin/make -f
# Debian package build rules file for ctwm
# Copyright 1997-1999 Joey Hess.
# Copyright 1999 Branden Robinson.
# Licensed under the GNU General Public License, version 2.  See the file
# /usr/share/common-licenses/GPL or <http://www.gnu.org/copyleft/gpl.txt>.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = `dpkg-buildflags --get CFLAGS`
LDFLAGS = `dpkg-buildflags --get LDFLAGS`
CPPFLAGS = `dpkg-buildflags --get CPPFLAGS`
export CFLAGS LDFLAGS CPPFLAGS

build-arch: build-stamp
build-stamp:
	dh_testdir

	CC=gcc xmkmf -DDontPreprocessManPages=0
	$(MAKE)

	>"$@"

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	[ ! -f Makefile ] || $(MAKE) clean
	rm -f Makefile

	dh_clean

install: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) DESTDIR=debian/ctwm install install.man
	# Don't ship pixmaps that are in fvwm-icons.
	rm debian/ctwm/usr/include/X11/pixmaps/datebook.xpm
	rm debian/ctwm/usr/include/X11/pixmaps/mail1.xpm
	rm debian/ctwm/usr/include/X11/pixmaps/term.xpm
	rm debian/ctwm/usr/include/X11/pixmaps/unknown1.xpm
	rm debian/ctwm/usr/include/X11/pixmaps/xcalc.xpm
	rm debian/ctwm/usr/include/X11/pixmaps/xman.xpm
	rm debian/ctwm/usr/include/X11/pixmaps/xterm.xpm

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs PROBLEMS README README.gnome TODO.gnome
	dh_installexamples example.ctwmrc levitte.ctwmrc debian/lynx.ctwmrc.m4 \
	  peterc.ctwmrc system.ctwmrc.gnome
	dh_installmenu
	dh_installmanpages
	dh_installchangelogs CHANGES
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# We build no architecture-independent packages, so the binary-indep rules is
# empty.
binary-indep:
build-indep:
build: build-arch

binary: binary-arch binary-indep
.PHONY: build clean binary-arch binary install build-indep

## ctwm 4.0.3

=== debian/changelog ===
ctwm (4.0.3-2) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + ctwm: Drop versioned constraint on x11-common in Pre-Depends.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Thu, 13 Oct 2022 13:57:15 +0100

ctwm (4.0.3-1) unstable; urgency=medium

  * QA upload.
  * New upstream release. (Closes: #417526)
    + Switch to new upstream location.
  * Bump Standards-Version to 4.6.0.
  * debian/control:
    + Apply "wrap-and-sort -abst".
    + Switch to cmake buildsystem.
    + Update Vcs-* fields.
    + Use Rules-Requires-Root: no.
  * debian/rules: Rewrite with dh sequencer.
  * debian/patches: Drop all previous patches for a clean packaging.
  * debian/copyright: Rewrite with machine-readable copyright.
  * debian/ctwm.desktop: Add desktop file for usr/share/xsessions/.
    (Closes: #330045) (LP: #395575)
  * debian/ctwm.alternatives: Use declarative alternatives system.

 -- Boyuan Yang <byang@debian.org>  Sun, 13 Mar 2022 11:01:49 -0400

=== debian/control ===
Source: ctwm
Section: x11
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 bison,
 cmake,
 debhelper-compat (= 13),
 flex,
 libice-dev,
 libjpeg-dev,
 librplay3-dev,
 libsm-dev,
 libx11-dev,
 libxext-dev,
 libxmu-dev,
 libxpm-dev,
 libxt-dev,
 m4 <!nocheck>,
 x11proto-core-dev,
 xutils-dev,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://www.ctwm.org
Vcs-Git: https://salsa.debian.org/debian/ctwm.git
Vcs-Browser: https://salsa.debian.org/debian/ctwm

Package: ctwm
Architecture: any
Depends:
 m4,
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 x11-common,
Provides:
 x-window-manager,
Description: Claude's Tab window manager
 ctwm is Claude Lecommandeur's extension to twm; in addition to the
 features of twm, it supports multiple virtual screens, the pixmap file
 format, pinnable ("sticky") menus, and other enhancements.

=== debian/watch ===
version=4
https://www.ctwm.org/download.html \
 dist/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## ctwm 4.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,10 @@
-cmake_minimum_required(VERSION 2.6)
-project(ctwm C)
+cmake_minimum_required(VERSION 3.6)
 
 # Figure our version
 file(READ "VERSION" vf_str)
 string(STRIP ${vf_str} vf_str)
-# Not currently using the split out variants
-if(0)
+# Use split variants for project() call.
+if(1)
 	set(version_file_re "([0-9]+)\\.([0-9]+)\\.([0-9]+)(.*)")
 	string(REGEX REPLACE ${version_file_re} "\\1" ctwm_version_major ${vf_str})
 	string(REGEX REPLACE ${version_file_re} "\\2" ctwm_version_minor ${vf_str})
@@ -15,6 +14,12 @@
 else()
 	set(ctwm_version_str ${vf_str})
 endif()
+
+# Now we can delcade that
+project(ctwm
+	VERSION ${ctwm_version_major}.${ctwm_version_minor}.${ctwm_version_patch}
+	LANGUAGES C
+	)
 
 # Modules we'll need
 include(CheckIncludeFiles)
@@ -27,6 +32,10 @@
 	message(FATAL_ERROR "Please build out of tree; don't run cmake "
 			"directly in the source tree.")
 endif(insrc)
+
+# Let cmake write out compile commands for external tools.  Requires
+# cmake 3.5+, but setting an unknown var won't hurt earlier versions.
+set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)
 
 
 #
@@ -124,14 +133,9 @@
 # with all our contents except the trivial main() wrapper, then build
 # ctwm with that; this makes it easy to build other binaries (like tests)
 # with access to all our internal funcs.
-add_library(ctwmlib STATIC ${CTWMSRC})
+add_library(ctwmlib OBJECT ${CTWMSRC})
 add_executable(ctwm "ctwm_wrap.c")
-
-# Keep ctwmlib before the shared libs.  With some ld(1)'s and build
-# environments that set --as-needed, having it after means that ld will
-# have already discarded all the shared libs as "unused" before it gets
-# to all the actual ctwm objects that need the symbols.
-target_link_libraries(ctwm ctwmlib)
+target_sources(ctwm PUBLIC $<TARGET_OBJECTS:ctwmlib>)
 target_link_libraries(ctwm ${CTWMLIBS})
 
 # This doesn't really serve much purpose at the moment, so it's not even
@@ -160,10 +164,6 @@
 # Pull in dtrace bits
 include(dtrace_support)
 
-# Let cmake write out compile commands for external tools.  Requires
-# cmake 3.5+, but setting an unknown var won't hurt earlier versions.
-set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)
-
 # Include tests
 include(CTest)
 if(BUILD_TESTING)

=== Makefile ===
--- 
+++ 
@@ -2,9 +2,10 @@
 all build ctwm man man-html man-all install clean: build/Makefile
 	( cd build && ${MAKE} ${@} )
 
+CMAKE?=cmake
 build/Makefile cmake: CMakeLists.txt
 	( mkdir -p build && cd build && \
-		cmake -DCMAKE_C_FLAGS:STRING="${CFLAGS}" ${CMAKE_EXTRAS} .. )
+		${CMAKE} -DCMAKE_C_FLAGS:STRING="${CFLAGS}" ${CMAKE_EXTRAS} .. )
 
 allclean distclean:
 	rm -rf build/*
@@ -22,13 +23,13 @@
 
 # Make sure everything's build before running tests
 .PHONY: test
-test:
+test: build/Makefile
 	( cd build && ${MAKE} test_bins )
 	( cd build && ${MAKE} CTEST_OUTPUT_ON_FAILURE=1 ${@} )
 
 # Reindent files
 indent:
-	astyle -n --options=tools/ctwm.astyle *.h *.c
+	astyle -n --options=tools/ctwm.astyle *.[ch] tests/*/*.[ch]
 
 
 # Build documentation files
@@ -83,7 +84,8 @@
 
 # Setup version file
 ${GEN}/version.c.in: ${GEN} version.c.in .bzr/checkout/dirstate
-	tools/rewrite_version_bzr.sh < version.c.in > ${GEN}/version.c.in
+	env BZR_CMD=brz tools/rewrite_version_bzr.sh < version.c.in \
+			> ${GEN}/version.c.in
 
 # Generate pregen'd manuals
 ${GEN}/ctwm.1: ${UMAN}/ctwm.1

=== tests/CMakeLists.txt ===
#
# Automated tests
#

set(CTWMBIN "ctwm")
set(CTWMPATH "${CMAKE_BINARY_DIR}/ctwm")
add_custom_target(test_bins)
add_dependencies(test_bins ctwm)


# Add some infrastructure for building executables for unit tests
#
# BIN - name of the binary to run.
# BINPATH - path of the binary to run.
# ARGS - Add'l arguments to the binary for the test
# WORKING_DIRECTORY - self-explanatory
#
# Currently, ${BINPATH} means a thing is already built, so we don't need
# to worry about building, that's just the path to run.  Else, ${BIN} is
# built from ${BIN}.c (though multiple calls with the same ${BIN} won't
# try to re-do the builds).  e.g., commonly, $BINPATH is used when we're
# running the main ctwm binary, instead of s test-specific bin.
#
# This is not un-janky, but it works, and we'll worry about cleaning it
# up if it gets worse.
function(ctwm_simple_unit_test TNAME)
	set(_opts ALLOW_DISPLAY)
	set(_arg_one BIN BINPATH WORKING_DIRECTORY)
	set(_arg_multi ARGS)
	cmake_parse_arguments(_ARGS "${_opts}" "${_arg_one}" "${_arg_multi}"
		${ARGN})

	# Maybe we're passed a specific path to run
	if(_ARGS_BINPATH)
		set(BIN_RUN "${_ARGS_BINPATH}")
	endif()

	# What's the binary name?
	if(_ARGS_BIN)
		set(BIN "${_ARGS_BIN}")
	else()
		set(BIN "${TNAME}")
	endif()

	# Derive path if we only got a name
	if(NOT BIN_RUN)
		set(BIN_RUN $<TARGET_FILE:${BIN}>)
	endif()

	# Building and linking it
	if(NOT TARGET ${BIN})
		add_executable(${BIN} EXCLUDE_FROM_ALL "${BIN}.c")
		target_sources(${BIN} PUBLIC $<TARGET_OBJECTS:ctwmlib>)

		# Few of our tests really need any of the X or other libs we pull in.
		# However, most of the .o's for ctwm itself are going to have some
		# ref out to them somewhere, so any tests that wind up pulling
		# functions from those are going to make the linker want to resolve
		# them when we link ${TNAME}.  So just unconditionally add them and
		# don't worry about which tests may not actually need 'em.
		target_link_libraries(${BIN} ${CTWMLIBS})

		# Add to pre-test target
		add_dependencies(test_bins ${BIN})
	endif()

	# And add the test itself
	add_test(NAME ${TNAME}
		COMMAND ${BIN_RUN} ${_ARGS_ARGS}
		WORKING_DIRECTORY ${_ARGS_WORKING_DIRECTORY}
		)

	# Don't allow $DISPLAY unless specifically requested.
	if(NOT _ARGS_ALLOW_DISPLAY)
		set_tests_properties(${TNAME} PROPERTIES
			ENVIRONMENT DISPLAY=
			)
	endif()

endfunction()


# Simple wrapper for when we want to explicitly skip a test (as opposed
# to just silently not doing it; better UX to say we're skipping one and
# why...)
#
# XXX This seems like the simplest way of actually "skip"'ing a test
# based on configure options.  That's nuts.  REQUIRED_FILES sounds like
# it would, but actually causes the test to "not run" and be considered
# failed   :(
function(ctwm_skip_unit_test TNAME REASON)
	add_test(NAME ${TNAME} COMMAND sh -c "echo Skipped: ${REASON} ; exit 99")
	set_tests_properties(${TNAME} PROPERTIES SKIP_RETURN_CODE 99)
endfunction()



# First a simple smoke test of the built binary
ctwm_simple_unit_test(run-info
	BIN ${CTWMBIN}
	BINPATH ${CTWMPATH}
	ARGS --info
	)
set_tests_properties(run-info PROPERTIES
	PASS_REGULAR_EXPRESSION "Twm version: "
	)


# Try parsing the system.ctwmrc
ctwm_simple_unit_test(cfgchk
	BIN ${CTWMBIN}
	BINPATH ${CTWMPATH}
	ARGS --cfgchk -f ${CMAKE_SOURCE_DIR}/system.ctwmrc
	)


# Simple test of m4 preprocessing, but we skip if built without m4.
if(USE_M4)
	add_subdirectory(test_m4)
else()
	ctwm_skip_unit_test(test_m4 "Built without USE_M4")
endif()


# A first run at a unit test
add_subdirectory(util_expand)

# RLayout stuff
add_subdirectory(layout)

# TwmKeys menu bits
add_subdirectory(menu_twmkeys)

=== tests/layout/CMakeLists.txt ===
# Test various rlayout-related bits

# Bits directly testing the funcs
ctwm_simple_unit_test(rlayout_overlap
	BIN test_layout
	ARGS overlap.tst
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)

ctwm_simple_unit_test(rlayout_test
	BIN test_layout
	ARGS test.tst
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)


# Test config parsing of MonitorLayout{} block
ctwm_simple_unit_test(rlayout_monitor_layout
	BIN test_monitor_layout
	ARGS -f ${CMAKE_CURRENT_SOURCE_DIR}/monitor_layout.ctwmrc)

=== tests/menu_twmkeys/CMakeLists.txt ===
# Test the strings for TwmKeys menu
ctwm_simple_unit_test(mk_twmkeys_entry BIN mk_twmkeys_entry)

=== tests/test_m4/CMakeLists.txt ===
# Test that m4 D'sTRT
ctwm_simple_unit_test(test_m4
	ARGS -f ${CMAKE_CURRENT_SOURCE_DIR}/ctwmrc)

=== tests/util_expand/CMakeLists.txt ===
# Test ExpandFilePath()
ctwm_simple_unit_test(path_expansion BIN t_efp)

=== debian/changelog ===
ctwm (4.1.0-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * debian/control: Add new build-dep libxrandr-dev.

 -- Boyuan Yang <byang@debian.org>  Mon, 25 Dec 2023 11:52:39 -0500

=== debian/control ===
--- 
+++ 
@@ -15,11 +15,12 @@
  libxext-dev,
  libxmu-dev,
  libxpm-dev,
+ libxrandr-dev,
  libxt-dev,
  m4 <!nocheck>,
  x11proto-core-dev,
  xutils-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://www.ctwm.org
 Vcs-Git: https://salsa.debian.org/debian/ctwm.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND =

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	        -DEXAMPLEDIR=/usr/share/doc/ctwm/examples/ \
            $(NULL)

# cope with buggy upstream
override_dh_auto_test:
	-dh_auto_test
